/*!
 * Module dependencies.
 */

var mongoose = require('mongoose');
var config = require('../../config/env/development');
var moment = require('moment');
var jwt = require('jwt-simple');
var utils = require("../../utils")
var passport = require('passport');
const { pass } = require('../../config/passport/local');
// const AdminUser = require('../models/adminuser');
var AdminUser = mongoose.model('adminuser');
// var AdminUser = mongoose.model('adminuser');

exports.login = function (req, res) {
    console.log("REQ = ", req.body);
    AdminUser.find().then(function(adminresult){
        console.log("ADMIN RESULT = ", adminresult);
    })
    AdminUser.findOne({
        email: req.body.email,
        password: req.body.password
    }).then(function (result) {
        console.log("RESULT = ", result);
        if (result) {
            res.json({ status: true, message: "Login Successfull.", data: result })
        } else {
            res.json({ status: false, message: "Invalid EmailId or Password.", data: result })
        }
    }).catch(function (err) {
        console.log("ERROR OCCURRED ON LOGIN. Error: ", err);
        res.json({ status: false, message: "Something went wrong. Please try again later." });
    })
}

exports.register = function (req, res) {
    var userObj = {
        email: req.body.email,
        password: req.body.password,
        role: "admin"
    }
    // console.log("REQUEST = ", req.body);
    AdminUser.findOne({ email: userObj.email }).then(function (data) {
        if (data) {
            res.json({ status: false, message: "EmailId already exists." })
        } else {
            AdminUser.create(userObj).then(function (result) {
                if (result) {
                    res.json({ status: true, message: "Registered Successfully.", data: result })
                } else {
                    res.json({ status: false, message: "Failed to Save Record.", data: result })
                }
            }).catch(function (err) {
                console.log("ERROR OCCURRED ON REGISTER. Error: ", err);
                res.json({ status: false, message: "Something went wrong. Please try again later." });
            })
        }
    }).catch(function (err) {
        console.log("ERROR OCCURRED ON REGISTER. Error: ", err);
        res.json({ status: false, message: "Something went wrong. Please try again later." });
    })
}

exports.deleteUser = function (req, res) {
    AdminUser.remove({ _id: req.query._id }).then(function (data) {
        if (data) {
            res.json({ status: true, message: "User Deleted Successfully." })
        } else {
            res.json({ status: false, message: "Something went wrong. Please try again later." })
        }
    }).catch(function (err) {
        console.log("ERROR OCCURRED ON DELETE USER. Error: ", err);
        res.json({ status: false, message: "Something went wrong. Please try again later." });
    })
}

exports.update = function (req, res) {
    var userId = req.params.userId;

    var updateParams = req.body;
    console.log("BODY = ', ", updateParams)
    // delete updateParams.__v
    AdminUser.findOneAndUpdate({ _id: userId }, { $set: updateParams }, { new: true, upsert: true }).exec(function (err, updatedTask) {
        if (err) {
            console.log("ERROR = ", err);
            return utils.sendFailureResponse(res, 500, 1011, err.message, 'Failed to update User', JSON.stringify(err.errors));
        } else {
            return utils.sendSuccessResponse(res, 200, updatedTask);
        }
    })
}

exports.getAllUser = function (req, res) {
    AdminUser.find().then(function (data) {
        if (data) {
            res.json({ status: true, message: "Found User Data.", data: data })
        } else {
            res.json({ status: false, message: "No data found." })
        }
    }).catch(function (err) {
        console.log("ERROR OCCURRED ON DELETE USER. Error: ", err);
        res.json({ status: false, message: "Something went wrong. Please try again later." });
    })
}

exports.forgotPassword = function (req, res) {
    AdminUser.findOne({ email: req.query.email }).then(function (result) {
        if (result) {
            console.log("RESULT = ", result);
            var resetToken = jwt.encode({ email: result.email }, config.jwtTokenSecret);
            var userObj = {
                firstName: result.email,
                resetClickToken: resetToken,
                email: result.email
            }
            utils.sendEmail("resetPassword", userObj)
            res.json({
                success: true,
                message: "Reset email sent to your email."
            })
        }
    })
}

// console.log("DECODED = ", jwt.decode("eyJ0eXAiOiJKV1QiLCJhbGciOiJIUzI1NiJ9.eyJlbWFpbCI6ImpiQGRpc29sdXRpb25zLm5ldCJ9.74hTrCGeRUYwp7N1DRRV6AYmE17jUQfNNzoTEif-nwg", config.jwtTokenSecret))

exports.setNewPassword = function (req, res) {
    console.log("REQUEST QUERY = ", req.query);
    // console.log(token = )
    var resetTokenDecoded = jwt.decode(req.query.resetToken, config.jwtTokenSecret);
    var password = req.query.password;
    var email = resetTokenDecoded.email;
    // if (resetTokenDecoded.email != email) {
    //     res.json({
    //         success: false,
    //         message: "Failed to reset password. Authentication failed."
    //     })
    // }

    AdminUser.updateOne({
        email: email
    }, {
        $set: {
            password: password
        }
    }).then(function (result) {
        if (result) {
            res.json({
                success: true,
                message: "Password Reset successfully."
            });
        } else {
            res.json({
                success: false,
                message: "Failed to reset password: Account with this email does not exist."
            });
        }
    }).catch(function (err) {
        res.json({
            success: false,
            message: "Failed to reset password. Please try again later."
        })
    })

}

exports.upload = function (req, res) {
 let ResponseData = []
  req.files.map(file => {
    ResponseData.push({
      fileType: file.mimetype,
      url: "http://restaurantassets.nayarkody.site/"+ file.path,
      _id: Date.now()
    })
  })

  res.send({
    status: true,
    files: ResponseData,
    message: 'success'
  })
}
