/*!
 * Module dependencies.
 */

var mongoose = require('mongoose');
var config = require('../../config/env/development');
var async = require('async');
var utils = require('../../utils');
var pushNotify = require('push-notify');
var gcm = pushNotify.gcm({
    apiKey: config.pushNotify.google.apiKey,
    retries: 1
});

gcm.on('transmitted', function (result, message, registrationId) {
    console.log(result, message, registrationId);
});

gcm.on('transmissionError', function (error, message, registrationId) {
    console.log(error, message, registrationId);
});

gcm.on('updated', function (result, registrationId) {
    console.log(result, registrationId);
});


exports.sendPushNotification = function (registrationIds, data) {
    gcm.send({
        registrationId: registrationIds,
        collapseKey: 'COLLAPSE_KEY',
        delayWhileIdle: true,
        timeToLive: 3,
        data: data
    });
}

// exports.sendPushNotification("fKYb9RUF_sw:APA91bGBUvWof-EQwPaKaooCnxF_f3xAyGrpO1L1I3rUKOuYu9WyMguQlRGLLmUz4VvlzcPpXl81Dz_ki_39g8pKV14v_Sr9K5bUYS3mPacvEpNrHtZadejdtOPv3aD0vo6LuMpN9_0X", "Shrinidhi is a bitch")
