/*!
 * Module dependencies.
 */

var mongoose = require('mongoose');
var config = require('../../config/env/development');
var moment = require('moment');
var jwt = require('jwt-simple');
var utils = require("../../utils")
var passport = require('passport');

exports.authenticatedUser = function (req, res) {
    utils.isAuthenticated(req, res, function (authenticated) {
        res.setHeader('content-type', 'text/javascript');
        if (authenticated) {
            res.send('var authenticatedUser = ' + JSON.stringify(req.user) + ';var isLoggedIn = true;')
        } else {
            res.send('var authenticatedUser = null;var isLoggedIn = false;')
        }
    });
}

exports.onGoogleLogin = function (req, res, next) {
    passport.authenticate('google', function (err, user) {
        if (err) {
            if (err.message == 'noUser') {
                return utils.sendFailureResponse(res, 404, 1002, err.message, 'No user found with given email');
            } else if (err.message == 'wrongPassword') {
                return utils.sendFailureResponse(res, 403, 1003, 'Authentication Failed', 'Wrong password');
            } else if (err.message == "emailNotVerified") {
                return utils.sendFailureResponse(res, 403, 1015, 'Email Verifcation', 'Email not verified, Please verify your email address');
            } else {
                return utils.sendFailureResponse(res, 500, 1001, 'Database Failure', err.message);
            }
        } else {
            var expires = moment().add(1, 'hours');
            var token = jwt.encode({
                iss: user._id,
                exp: expires
            }, config.jwtTokenSecret);

            res.cookie('accesstoken', token, { expires: new Date(expires), domain: '.' + config.domain, path: '/', secure: false });
            return res.redirect(config.cms + '/building');
        }
    })(req, res, next);
};
