/*!
* Module dependencies
*/

var mongoose = require('mongoose');
var Schema = mongoose.Schema;

var CharacterSchema = new Schema({
    name: {
        type: String,
        required: true
    },
    type: {
        type: Number,
        required: true,
        unique: true
    },
    maxCoins: {
        type: Number,
        required: true
    },
    unlockLevel: {
        type: Number,
        required: true
    },
    animationFile: {
        type: String,
        required: true
    },
    imageUrl: {
        type: String,
        required: true
    },
    gender: {
        type: String,
        enum: ['Male', 'Female'],
        required: true
    },
    category: {
        type: String,
        enum: ['normal', 'buyable', 'reward']
    },
    cost: {
        type: Number,
        default: 0
    },
    dialogues: {
        generic: [{type: String}],
        inShop: [{type: String}],
        afterShop: [{type: String}],
        frontDesk: [{type: String}],
        nearDecor: [{type: String}]
    },
    translation: {
        type: Object
    },
    excludedUtilities: [{
        type: Number
    }]
});

/**
* Register
*/

mongoose.model('Character', CharacterSchema);
