/*!
* Module dependencies
*/

var mongoose = require('mongoose');
var Schema = mongoose.Schema;

var LevelSchema = new Schema({
    level: {
        type: Number,
        required: true,
        unique: true
    },
    maxCoins: {
        type: Number,
        required: true
    },
    landSize: {
        width: {
            type: Number,
            required: true
        },
        height: {
            type: Number,
            required: true
        }
    },
    upgradeCost: {
        type: Number,
        required: true
    },
    maxShoppers: {
        type: Number,
        required: true
    },
    maxFloors: {
        type: Number,
        default: 0,
        required: true
    }
});

/**
* Register
*/

mongoose.model('Level', LevelSchema);
