
/**
 * Module dependencies.
 */

var mongoose = require('mongoose');
var adminuser = require('../../app/controllers/adminuser');
var utils = require('../../utils');

const multer = require('multer')

var storage = multer.diskStorage({
  destination: function (req, file, cb) {
    return cb(null, "images/")
  },
  filename: function (req, file, cb) {
    let extArray = file.mimetype.split('/')
    let extension =
      extArray[extArray.length - 1] == 'mpeg'
        ? 'mp3'
        : extArray[extArray.length - 1]
    cb(null, file.originalname) //Appending .jpg
  }
})

var upload = multer({ storage: storage })

/**
 * Expose
 */
module.exports = function (app, passport) {

    // app.post('/auth/email/login', passport.authenticate('local'), admin.login);

    app.post('/adminuser/login', adminuser.login);

    app.post('/adminuser/register', adminuser.register);

    app.delete('/adminuser/deleteUser', adminuser.deleteUser);

    app.get('/adminuser/getAllUser', adminuser.getAllUser);

    app.put('/adminuser/:userId', adminuser.update);

    app.get('/adminuser/forgotPassword', adminuser.forgotPassword);

    app.get('/adminuser/setNewPassword', adminuser.setNewPassword);

    app.post('/adminuser/upload',upload.array('file'),adminuser.upload);
    // app.post('/auth/email/login', users.login);
    //
    // app.get('/user', utils.ensureAuthenticated, users.read);
    //
    // app.post('/users', users.create);
    //
    // app.get('/users/:userId', users.load);
    //
    // app.put('/users/:userId', utils.ensureAuthenticated, users.update);
    //
    // app.delete('/users/:userId', users.delete);
    //
    // app.get('/user/verify', users.verify);
    //
    // app.get('/user.js', users.authenticatedUser);
    //
    // app.post('/user/forgotpassword', users.forgotPassword);
    //
    // app.get('/user/resetpage', users.resetpage);
    //
    // app.post('/user/resetpassword', users.resetPassword);
};
