/**
 * Module dependencies.
 */

var mongoose = require('mongoose')
var profile = require('../../app/controllers/profile')
var utils = require('../../utils')
var pushNotify = require('../../app/controllers/pushnotify')

/**
 * Expose
 */

module.exports = function (app, passport) {
  // ?userid=:userid -> return a list of profiles that match the userid
  // app.get('/profiles/search', utils.isAuthenticatedProfile, profile.search)
  app.get('/profiles/search', profile.search)

  // app.get('/profiles', utils.ensureAuthenticated, profile.read);
  app.get('/profiles', profile.read)

  app.get('/default-profile', profile.getDefaultProfile)

  // app.put('/default-profile', utils.ensureAuthenticated, profile.saveDefaultProfile);
  app.put('/default-profile', profile.saveDefaultProfile)

  // app.get('/profiles/:deviceId', utils.isAuthenticatedProfile, profile.detail);
  app.get('/profiles/:deviceId', profile.detail)

  // app.post('/profiles/:deviceId', utils.isAuthenticatedProfile, profile.update);
  app.post('/profiles/:deviceId', profile.update)

  // app.post('/profiles', utils.isAuthenticatedProfile, profile.create);
  app.post('/profiles', profile.create)

  // app.delete('/profiles/:profileId', utils.ensureAuthenticated, profile.delete);
  app.delete('/profiles/:profileId', profile.delete)

  app.get('/getUsersByAppealCount', profile.getUsersByAppealCount)

  app.get('/getUsersByCoins', profile.getUsersByCoins)
  app.get('/getUserslevelnumber', profile.getUserslevelnumber)

  app.get('/getUsers', profile.getUsers)

  app.post('/updateUser', profile.updateUser)

  app.get('/deleteUserProfile', profile.deleteUserProfile)
}
